#ifndef MORPHING_TABLE_H
#define MORPHING_TABLE_H
/***************************************************************************
 *
 * MorphingTable.h: a morphing table, where the cells change their background
 *                  color
 *
 * (c) 2004 Thomas Unterthiner
 *
 * created:      22. May 2004
 * last change:  $Date: 2004/05/31 13:42:18 $
 *
 ***************************************************************************/

#include "Surface.h"
#include <vector>
#include <ctime>

//#define DEBUG

/*
 * a MorphingTable is a table which cells change their background color randomly
 */
class MorphingTable
{
	public:
		MorphingTable(int rows, int columns, Surface& surface);
		~MorphingTable() {}

		void morph();
		void draw();

	private:
		long chooseCell();
		void drawPerPixel();
		
		int rows_;
		int cols_;
		int cellCount_;
		float cellWidth;   // to see why cellWidth and cellHeight are float,
		float cellHeight;  // check out the implementation of the Constructor
		Surface& surface_;
		std::vector<Surface::Color> cells_;
		int randMaxToCellsRatio_; 
};

#endif

