#ifndef SDL_SCREENSAVER_H
#define SDL_SCREENSAVER_H
/***************************************************************************
 *
 * SdlScreensaver.h: a screensaver implemented with SDL
 *
 * (c) 2004 Thomas Unterthiner
 *
 * created:      22. May 2004
 * last change:  $Date: 2004/05/31 13:32:51 $
 *
 ***************************************************************************/
 
#include <SDL/SDL.h>
#include "Surface.h"
#include "MorphingTable.h"
#include "ConfigFile.h"


//#define DEBUG


struct badConfigFile // used as exeption
{
};



class SdlScreensaver
{
	public:
		SdlScreensaver();
		~SdlScreensaver();
	
		void run();

	private:
	
		void checkInput();
		
		bool run_;
		Surface* display_;
		MorphingTable* table_;
		ConfigFile config_;
	
		// SETTINGS:
		const int xRes;
		const int yRes;
		const int bpp;
  		const int rows;
		const int cols;
		const int changesPerFrame;
		const bool fullscreen;

};

#endif

