#ifndef SDL_SURFACE_H
#define SDL_SURFACE_H
/***************************************************************************
 *
 * SdlSurface.h: drawing-surface implemented with libSDL
 *
 * (c) 2004 Thomas Unterthiner
 *
 * created:      22. May 2004
 * last change:  $Date: 2004/05/26 16:03:22 $
 *
 ***************************************************************************/


#include "Surface.h"
#include <cstdlib>
#include <SDL/SDL.h>

class SdlSurface : public Surface
{
	public:
		SdlSurface(int xRes, int yRes, int bpp, bool fullscreen);
		~SdlSurface();
		
		virtual void clear();
		virtual void update();

 		virtual int getHeight();
 		virtual int getWidth();
		
		// primitives
		virtual void putPixel(int x, int y, Color& color);
		virtual void drawLine(int x1, int y1, int x2, int y2, Color& color)
			{fprintf(stderr, "WARNING: SdlSurface::drawLine() not implemented\n");}
		virtual void drawCircle(int x, int y, int r, Color& color)
  			{fprintf(stderr, "WARNING: SdlSurface::drawCircle() not implemented\n");}

 		virtual void fillRect(int x1, int y1, int x2, int y2, Color& color);

		virtual void beforeDrawing()
  			{if (SDL_MUSTLOCK(surface_)) SDL_LockSurface(surface_);}
		virtual void afterDrawing()
  			{if (SDL_MUSTLOCK(surface_)) SDL_UnlockSurface(surface_);}

	private:
		SDL_Surface* surface_;
};

#endif

