#ifndef SURFACE_H
#define SURFACE_H
/***************************************************************************
 *
 * Surface.h: interface for drawing-surfaces
 *
 * (c) 2004 Thomas Unterthiner
 *
 * created:      14. Apr. 2004
 * last change:  $Date: 2004/05/26 16:03:22 $
 *
 ***************************************************************************/
 
class Surface
{
	public:
		struct Color
		{
			int r;
			int g;
			int b;
			Color(int r_ = 0, int g_ = 0, int b_ = 0)
	   			: r(r_), g(g_), b(b_) {}
		};
		
		virtual void update() = 0;
		virtual void clear() = 0;
		
		virtual int getHeight() = 0;
		virtual int getWidth() = 0;

		virtual void beforeDrawing() = 0;
		virtual void afterDrawing() = 0;
    		
		// primitives
		virtual void putPixel(int x, int y, Color& color) = 0;
		virtual void drawLine(int x1, int y1, int x2, int y2, Color& color) = 0;
		virtual void drawCircle(int x, int y, int r, Color& color) = 0;
		
		virtual void fillRect(int x1, int y1, int x2, int y2, Color& color) = 0;
};

#endif

